#include "pbcontrol.h"

ifont* PBControll::cfont = NULL;
void PBGroup::draw(bool no_redraw){
  for(int i=0;i<children.size();++i){
    children[i]->draw();
  }
  if(!no_redraw){
    PartialUpdateBW(x,y,w,h);
  }
}
int PBGroup::handle(int type,int par1,int par2){
  for(int i=0;i<children.size();++i){
    if(children[i]->handle(type,par1,par2))return 1;
  }
  if(EVT_KEYPRESS == type){
    switch(par1){
    case KEY_LEFT:
    case KEY_UP:
    case KEY_PREV:
    for(int i=0;i<children.size();++i){
      if(children[i]->focused){
        if(i>0){
          children[i]->focused=false;
          children[i-1]->focused=true;
          draw(true);
        }
        break;
      }
    }
    break;
    case KEY_RIGHT:
    case KEY_DOWN:
    case KEY_NEXT:
    for(int i=0;i<children.size();++i){
      if(children[i]->focused){
        if(i<children.size()-1){
          children[i]->focused=false;
          children[i+1]->focused=true;
          draw(true);
        }
        break;
      }
    }
    break;
    }
  }
}

void PBGroup::add(PBControl_ptr ch){
  children.push_back(ch);
  ch->parent(this);
}

PBGroup::~PBGroup(){
  for(int i=0;i<children.size();++i){
    delete children[i];
  }
}

PBMenuButton* PBMenuButton::activemenu=NULL;
void PBMenuButton::menu_handler(int item)
{
  if(activemenu)activemenu->do_callback((void*)item);
}
void PBMenuButton::do_menu(){
  menus = _itemfunc();
  if(_menu)delete[] _menu;
  _menu=new imenu[menus.size()+1];
  int i=0;
  for(;i<menus.size();++i){
    _menu[i].type=ITEM_ACTIVE;
    _menu[i].index=i;
    _menu[i].text=const_cast<char*>(menus[i].c_str());
    _menu[i].submenu=NULL;
  }
  _menu[i].type=0;
  _menu[i].index=0;
  _menu[i].text=NULL;
  _menu[i].submenu=NULL;
  activemenu=this;
  OpenMenu(_menu,0,x,y+h,menu_handler);
}

