#include <inkview.h>
#include "../Misc/Master.h"
#include "../Misc/Bank.h"
#include <vector>

class MasterUI{
  public:
  Master* master;
  struct note{
    int nmb;
    float basefreq;
    bool play;
    bool sustain;
    int nt_sync_mode;
    int x,y,w,h;
    bool black;
  };
  int midivel;
  enum ACCORD_MODE{SINGLE=0,QUINT=1,MAJOR=2,MINOR=3}acco_mode;

  std::vector<note> vkeyboard;

  MasterUI(Master*,int*);
  void draw_board();
  void init_board();
  int pitch_note(int px,int py);
  int mute_note(int px,int py);
  static MasterUI* mui;
};

extern int master_main_handler(int type,int par1,int par2);
